
:-object wasp2 : [bcilib].

var url = './street/street5.wrl'.

var timelimit = 120.

main :-
	text_area(Browser),
	set_output(Browser),
	format('Loading street1 from ~w~n', [url]),
	loadURL(url),
	format('The bus1 is going to jump in front of you in 5 seconds,~n'),
	format('then you can drive the bus for ~w seconds~n', [timelimit]),
 	delay(5000),
 	jump_to(bus1, me),
 	drive(bus1, me).

jump_to(Object, Agent) :-
	getViewpointPositionEx(Agent,X,_Y,Z),
	Z1 is Z-5,
	setPosition(Object,X, 0.0 ,Z1).	

drive(Object, Agent) :-
	--timelimit,
	timelimit > 0, !,
	format('time left: ~w seconds~n', [timelimit]),
	delay(1000),
	getViewpointPositionEx(Agent,X,_Y,Z),
	getViewpointOrientationEx(Agent,_X2,Y2,_Z2,R2),
	setPosition(Object,X, 0.0 ,Z),
	R3 is sign(Y2)*R2 + 1.571,
	setRotation(Object,0.0,1.0,0.0,R3),
	drive(Object,Agent).

drive(_, _).

getViewpointPositionEx(_,X,Y,Z) :- getSFVec3f(proxSensor,position,X,Y,Z).
getViewpointOrientationEx(_,X,Y,Z,R):- getSFRotation(proxSensor,orientation,X,Y,Z,R).



:-end_object wasp2.

